#!/bin/sh

PWD=`pwd`
TMPDIR="cert_tmp"
mkdir $TMPDIR
cp openssl.cnf $TMPDIR
mkdir -p $TMPDIR/demoCA/private/
mkdir -p $TMPDIR/demoCA/newcerts
mkdir -p $TMPDIR/demoCA/certs
mkdir -p $TMPDIR/demoCA/crl
mkdir -p $TMPDIR/certmka
cd $TMPDIR
touch demoCA/index.txt
echo "01" > demoCA/serial

#Generate self-signed CA
  echo -e ".\n.\n.\n.\n.\n`hostname`\n.\n" | \
    openssl req -new -x509 -nodes \
                -keyout demoCA/private/cakey.pem \
		-out demoCA/cacert.pem -days 3650  2>/dev/null 1>&2


#Generate certificate and sign request
  echo -e  ".\n.\n.\n.\n.\nccl\n.\n\n\n" | \
    openssl req  -new -nodes \
		 -keyout key.pem -out newreq.pem \
		 -days 3650\
		-config ./openssl.cnf 2>/dev/null 1>&2
  cat newreq.pem key.pem > new.pem

#Sign certificate with newly created CA
echo -e "y\ny\n" | openssl ca -policy policy_anything -out cert.pem -in new.pem -config ./openssl.cnf 2>/dev/null 1>&2
sleep 2


cp demoCA/cacert.pem CAcert.pem
cp CAcert.pem certmka/CA.pem
cat key.pem cert.pem > certmka/cert.pem

#Se copian los certificados

	cd certmka/
	
	declare -a a_user #Definiendo el array
	
	filename=/etc/passwd
	
	a_user=(`cat $filename | grep -i 'home' | cut -d: -f 1`)
	
	#root
	
	if [ -d ~/.mkahawa ]; then
        	#echo "el directorio existe"
		cp *pem ~/.mkahawa
		chmod +x ~/.mkahawa/cert.pem
	else
	       	#echo "el directorio no existe"
		mkdir ~/.mkahawa
		chown -R ${a_user[0]} ~/.mkahawa
		cp *pem ~/.mkahawa
		chmod +x ~/.mkahawa/cert.pem
	fi


	#user.
	#val=$(cat /etc/passwd | grep -i 'home' | cut -d: -f 1)
	
	for val in ${a_user[@]}

	do 	

	if [ -d /home/$val/.mkahawa ]; then
        	#echo "el directorio existe"
		cp *pem /home/$val/.mkahawa
		chown -R $val /home/$val/.mkahawa
		chgrp -R $val /home/$val/.mkahawa
		chmod +x /home/$val/.mkahawa/cert.pem
	else
	       	#echo "el directorio no existe"
		mkdir /home/$val/.mkahawa
		chown -R  $val /home/$val/.mkahawa
		chgrp -R  $val /home/$val/.mkahawa
		cp *pem /home/$val/.mkahawa
		chmod +x /home/$val/.mkahawa/cert.pem
	fi

	done	

#Luego se borra la carpeta temporal
cd ../../
rm -rf cert_tmp

#End
